diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/block-ack-test-suite.cc ns-3.34/src/wifi/test/block-ack-test-suite.cc
--- ns-3.33/src/wifi/test/block-ack-test-suite.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/block-ack-test-suite.cc	2021-07-14 10:31:07.000000000 -0700
@@ -681,7 +1362,7 @@
   BlockAckAggregationDisabledTest (bool txop);
   virtual ~BlockAckAggregationDisabledTest ();
 
-  virtual void DoRun (void);
+  void DoRun (void) override;
 
 
 private:
@@ -755,7 +1436,7 @@
   WifiMacHeader hdr;
   p->PeekHeader (hdr);
 
-  if (m_txSinceBar == 9 || m_txTotal == 14)
+  if (m_nBar < 2 && (m_txSinceBar == 9 || m_txTotal == 14))
     {
       NS_TEST_ASSERT_MSG_EQ (hdr.IsBlockAckReq (), true, "Didn't get a BlockAckReq when expected");
     }
@@ -814,15 +1495,15 @@
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_STANDARD_80211a);
-  wifi.SetAckPolicySelectorForAc (AC_BE, "ns3::ConstantWifiAckPolicySelector",
-                                  "BaThreshold", DoubleValue (0.125));
+  wifi.SetStandard (WIFI_STANDARD_80211n_5GHZ);
+  Config::SetDefault ("ns3::WifiDefaultAckManager::BaThreshold", DoubleValue (0.125));
   wifi.SetRemoteStationManager ("ns3::IdealWifiManager");
 
   WifiMacHelper mac;
   Ssid ssid = Ssid ("ns-3-ssid");
   mac.SetType ("ns3::StaWifiMac",
-               "QosSupported", BooleanValue (true),
+               "BE_MaxAmsduSize", UintegerValue (0),
+               "BE_MaxAmpduSize", UintegerValue (0),
                "Ssid", SsidValue (ssid),
                /* setting blockack threshold for sta's BE queue */
                "BE_BlockAckThreshold", UintegerValue (2),
@@ -832,7 +1513,8 @@
   staDevices = wifi.Install (phy, mac, wifiStaNode);
 
   mac.SetType ("ns3::ApWifiMac",
-               "QosSupported", BooleanValue (true),
+               "BE_MaxAmsduSize", UintegerValue (0),
+               "BE_MaxAmpduSize", UintegerValue (0),
                "Ssid", SsidValue (ssid),
                "BeaconGeneration", BooleanValue (true));
 
@@ -952,6 +1634,9 @@
   AddTestCase (new PacketBufferingCaseB, TestCase::QUICK);
   AddTestCase (new OriginatorBlockAckWindowTest, TestCase::QUICK);
   AddTestCase (new CtrlBAckResponseHeaderTest, TestCase::QUICK);
+  AddTestCase (new BlockAckRecipientBufferTest (0), TestCase::QUICK);
+  AddTestCase (new BlockAckRecipientBufferTest (4090), TestCase::QUICK);
+  AddTestCase (new MultiStaCtrlBAckResponseHeaderTest, TestCase::QUICK);
   AddTestCase (new BlockAckAggregationDisabledTest (false), TestCase::QUICK);
   AddTestCase (new BlockAckAggregationDisabledTest (true), TestCase::QUICK);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/channel-access-manager-test.cc ns-3.34/src/wifi/test/channel-access-manager-test.cc
--- ns-3.33/src/wifi/test/channel-access-manager-test.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/channel-access-manager-test.cc	2021-07-14 10:31:07.000000000 -0700
@@ -21,8 +21,8 @@
 #include "ns3/test.h"
 #include "ns3/simulator.h"
 #include "ns3/channel-access-manager.h"
+#include "ns3/frame-exchange-manager.h"
 #include "ns3/qos-txop.h"
-#include "ns3/mac-low.h"
 
 using namespace ns3;
 
@@ -58,8 +58,22 @@
   /// allow ChannelAccessManagerTest class access
   friend class ChannelAccessManagerTest<TxopType>;
 
-  /// Inherited
-  void DoDispose (void);
+  /// \copydoc ns3::Txop::DoDispose
+  void DoDispose (void) override;
+  /// \copydoc ns3::Txop::NotifyChannelAccessed
+  void NotifyChannelAccessed (Time txopDuration = Seconds (0)) override;
+  /// \copydoc ns3::Txop::NotifyInternalCollision
+  void NotifyInternalCollision (void) override;
+  /// \copydoc ns3::Txop::HasFramesToTransmit
+  bool HasFramesToTransmit (void) override;
+  /// \copydoc ns3::Txop::NotifyChannelSwitching
+  void NotifyChannelSwitching (void) override;
+  /// \copydoc ns3::Txop::NotifySleep
+  void NotifySleep (void) override;
+  /// \copydoc ns3::Txop::NotifyWakeUp
+  void NotifyWakeUp (void) override;
+  /// \copydoc ns3::Txop::GenerateBackoff
+  void GenerateBackoff (void) override;
 
   typedef std::pair<uint64_t,uint64_t> ExpectedGrant; //!< the expected grant typedef
   typedef std::list<ExpectedGrant> ExpectedGrants; //!< the collection of expected grants typedef
@@ -76,72 +90,12 @@
   ExpectedGrants m_expectedGrants; //!< expected grants
 
   /**
-   * \returns true if access has been requested for this function and
-   *          has not been granted already, false otherwise.
-   */
-  bool IsAccessRequested (void) const;
-  /**
-   * Notify that access request has been received.
-   */
-  void NotifyAccessRequested (void);
-  /**
-   * Notify the Txop that access has been granted.
-   */
-  void NotifyAccessGranted (void);
-  /**
-   * Notify the Txop that internal collision has occurred.
-   */
-  void NotifyInternalCollision (void);
-  /**
-   * Generate a new backoff now.
-   */
-  void GenerateBackoff (void);
-  /**
    * Check if the Txop has frames to transmit.
    * \return true if the Txop has frames to transmit.
    */
-  bool HasFramesToTransmit (void);
-  /**
-   * When a channel switching occurs, enqueued packets are removed.
-   */
-  void NotifyChannelSwitching (void);
-  /**
-   * When sleep operation occurs, if there is a pending packet transmission,
-   * it will be reinserted to the front of the queue.
-   */
-  void NotifySleep (void);
-  /**
-   * When wake up operation occurs, channel access will be restarted.
-   */
-  void NotifyWakeUp (void);
 
   ChannelAccessManagerTest<TxopType> *m_test; //!< the test DCF/EDCA manager
   uint32_t m_i; //!< the index of the Txop
-  bool m_accessRequested; //!< true if access requested
-};
-
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * \brief Mac Low Stub
- */
-class MacLowStub : public MacLow
-{
-public:
-  MacLowStub ()
-  {
-  }
-  /**
-   * This function indicates whether Simulator::Now is in the CF period.
-   *
-   * \return true if Simulator::Now is in CF period,
-   *         false otherwise
-   */
-  bool IsCfPeriod (void) const
-  {
-    return false;
-  }
 };
 
 /**
@@ -185,25 +139,50 @@
   }
 
 private:
-  // Inherited from base class
-  Time GetSifs (void) const
+  Time GetSifs (void) const override
   {
     return m_sifs;
   }
 
-  Time GetSlot (void) const
+  Time GetSlot (void) const override
   {
     return m_slot;
   }
 
-  Time GetEifsNoDifs (void) const
+  Time GetEifsNoDifs (void) const override
   {
     return m_eifsNoDifs;
   }
 
-  Time m_slot;        // slot duration
-  Time m_sifs;        // SIFS duration
-  Time m_eifsNoDifs;  // EIFS duration minus a DIFS
+  Time m_slot;        //!< slot duration
+  Time m_sifs;        //!< SIFS duration
+  Time m_eifsNoDifs;  //!< EIFS duration minus a DIFS
+};
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Frame Exchange Manager Stub
+ */
+class FrameExchangeManagerStub : public FrameExchangeManager
+{
+public:
+  FrameExchangeManagerStub ()
+  {
+  }
+  /**
+   * Request the FrameExchangeManager to start a frame exchange sequence.
+   *
+   * \param dcf the channel access function that gained channel access. It is
+   *            the DCF on non-QoS stations and an EDCA on QoS stations.
+   * \return true if a frame exchange sequence was started, false otherwise
+   */
+  bool StartTransmission (Ptr<Txop> dcf) override
+  {
+    dcf->NotifyChannelAccessed ();
+    return true;
+  }
 };
 
 /**
@@ -217,7 +196,7 @@
 {
 public:
   ChannelAccessManagerTest ();
-  virtual void DoRun (void);
+  void DoRun (void) override;
 
   /**
    * Notify access granted function
@@ -386,7 +365,7 @@
 
   typedef std::vector<Ptr<TxopTest<TxopType>>> TxopTests; //!< the TXOP tests typedef
 
-  Ptr<MacLowStub> m_low; //!< the MAC low stubbed
+  Ptr<FrameExchangeManagerStub> m_feManager; //!< the Frame Exchange Manager stubbed
   Ptr<ChannelAccessManagerStub> m_ChannelAccessManager; //!< the channel access manager
   TxopTests m_txop; //!< the vector of Txop test instances
   uint32_t m_ackTimeoutValue; //!< the Ack timeout value
@@ -402,8 +381,7 @@
 template <typename TxopType>
 TxopTest<TxopType>::TxopTest (ChannelAccessManagerTest<TxopType> *test, uint32_t i)
   : m_test (test),
-    m_i (i),
-    m_accessRequested (false)
+    m_i (i)
 {
 }
 
@@ -412,28 +390,14 @@
 TxopTest<TxopType>::DoDispose (void)
 {
   m_test = 0;
-  Txop::DoDispose ();
-}
-
-template <typename TxopType>
-bool
-TxopTest<TxopType>::IsAccessRequested (void) const
-{
-  return m_accessRequested;
+  TxopType::DoDispose ();
 }
 
 template <typename TxopType>
 void
-TxopTest<TxopType>::NotifyAccessRequested (void)
+TxopTest<TxopType>::NotifyChannelAccessed (Time txopDuration)
 {
-  m_accessRequested = true;
-}
-
-template <typename TxopType>
-void
-TxopTest<TxopType>::NotifyAccessGranted (void)
-{
-  m_accessRequested = false;
+  Txop::m_access = Txop::NOT_REQUESTED;
   m_test->NotifyAccessGranted (m_i);
 }
 
@@ -549,7 +513,7 @@
       state->m_expectedGrants.pop_front ();
       NS_TEST_EXPECT_MSG_EQ (Simulator::Now (), MicroSeconds (expected.second), "Expected grant is now");
     }
-  state->m_accessRequested = false;
+  state->Txop::m_access = Txop::NOT_REQUESTED;
 }
 
 template <typename TxopType>
@@ -594,8 +558,8 @@
 ChannelAccessManagerTest<TxopType>::StartTest (uint64_t slotTime, uint64_t sifs, uint64_t eifsNoDifsNoSifs, uint32_t ackTimeoutValue)
 {
   m_ChannelAccessManager = CreateObject<ChannelAccessManagerStub> ();
-  m_low = CreateObject<MacLowStub> ();
-  m_ChannelAccessManager->SetupLow (m_low);
+  m_feManager = CreateObject<FrameExchangeManagerStub> ();
+  m_ChannelAccessManager->SetupFrameExchangeManager (m_feManager);
   m_ChannelAccessManager->SetSlot (MicroSeconds (slotTime));
   m_ChannelAccessManager->SetSifs (MicroSeconds (sifs));
   m_ChannelAccessManager->SetEifsNoDifs (MicroSeconds (eifsNoDifsNoSifs + sifs));
@@ -610,7 +574,6 @@
   txop->SetAifsn (aifsn);
   m_txop.push_back (txop);
   txop->SetChannelAccessManager (m_ChannelAccessManager);
-  txop->SetMacLow (m_low);
 }
 
 template <typename TxopType>
@@ -618,7 +581,6 @@
 ChannelAccessManagerTest<TxopType>::EndTest (void)
 {
   Simulator::Run ();
-  Simulator::Destroy ();
 
   for (typename TxopTests::const_iterator i = m_txop.begin (); i != m_txop.end (); i++)
     {
@@ -631,8 +593,10 @@
     }
   m_txop.clear ();
 
+  m_ChannelAccessManager->Dispose ();
   m_ChannelAccessManager = 0;
-  m_low = 0;
+  m_feManager = 0;
+  Simulator::Destroy ();
 }
 
 template <typename TxopType>
@@ -1142,7 +1106,7 @@
   StartTest (4, 6, 10);
   AddTxop (1);
   AddRxOkEvt (20, 30);
-  AddAccessRequest (52, 20, 60, 0);
+  AddAccessRequest (58, 20, 60, 0);
   EndTest ();
 
   // Check alignment at slot boundary after successful reception (backoff = 0):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/examples-to-run.py ns-3.34/src/wifi/test/examples-to-run.py
--- ns-3.33/src/wifi/test/examples-to-run.py	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/examples-to-run.py	2021-07-14 10:31:07.000000000 -0700
@@ -29,13 +29,11 @@
     ("wifi-phy-configuration --testCase=18", "True", "False"),
     ("wifi-phy-configuration --testCase=19", "True", "False"),
     ("wifi-phy-configuration --testCase=20", "True", "False"),
-    ("wifi-phy-configuration --testCase=21", "True", "False"),
     ("wifi-manager-example --wifiManager=Aarf --standard=802.11a --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Aarf --standard=802.11a --rtsThreshold=0 --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Aarf --standard=802.11a --maxSlrc=1 --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Aarf --standard=802.11b --serverChannelWidth=22 --clientChannelWidth=22 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Aarf --standard=802.11g --stepTime=0.1", "True", "False"),
-    ("wifi-manager-example --wifiManager=Aarf --standard=802.11-holland --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Aarf --standard=802.11p-10MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Aarf --standard=802.11p-5MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Aarfcd --standard=802.11a --stepTime=0.1", "True", "True"),
@@ -43,7 +41,6 @@
     ("wifi-manager-example --wifiManager=Aarfcd --standard=802.11a --maxSlrc=1 --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Aarfcd --standard=802.11b --serverChannelWidth=22 --clientChannelWidth=22 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Aarfcd --standard=802.11g --stepTime=0.1", "True", "False"),
-    ("wifi-manager-example --wifiManager=Aarfcd --standard=802.11-holland --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Aarfcd --standard=802.11p-10MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Aarfcd --standard=802.11p-5MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Amrr --standard=802.11a --stepTime=0.1", "True", "True"),
@@ -51,7 +48,6 @@
     ("wifi-manager-example --wifiManager=Amrr --standard=802.11a --maxSlrc=1 --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Amrr --standard=802.11b --serverChannelWidth=22 --clientChannelWidth=22 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Amrr --standard=802.11g --stepTime=0.1", "True", "False"),
-    ("wifi-manager-example --wifiManager=Amrr --standard=802.11-holland --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Amrr --standard=802.11p-10MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Amrr --standard=802.11p-5MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Arf --standard=802.11a --stepTime=0.1", "True", "True"),
@@ -59,7 +55,6 @@
     ("wifi-manager-example --wifiManager=Arf --standard=802.11a --maxSlrc=1 --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Arf --standard=802.11b --serverChannelWidth=22 --clientChannelWidth=22 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Arf --standard=802.11g --stepTime=0.1", "True", "False"),
-    ("wifi-manager-example --wifiManager=Arf --standard=802.11-holland --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Arf --standard=802.11p-10MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Arf --standard=802.11p-5MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Cara --standard=802.11a --stepTime=0.1", "True", "True"),
@@ -67,7 +62,6 @@
     ("wifi-manager-example --wifiManager=Cara --standard=802.11a --maxSlrc=1 --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Cara --standard=802.11b --serverChannelWidth=22 --clientChannelWidth=22 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Cara --standard=802.11g --stepTime=0.1", "True", "False"),
-    ("wifi-manager-example --wifiManager=Cara --standard=802.11-holland --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Cara --standard=802.11p-10MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Cara --standard=802.11p-5MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Onoe --standard=802.11a --stepTime=0.1", "True", "True"),
@@ -75,7 +69,6 @@
     ("wifi-manager-example --wifiManager=Onoe --standard=802.11a --maxSlrc=1 --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Onoe --standard=802.11b --serverChannelWidth=22 --clientChannelWidth=22 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Onoe --standard=802.11g --stepTime=0.1", "True", "False"),
-    ("wifi-manager-example --wifiManager=Onoe --standard=802.11-holland --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Onoe --standard=802.11p-10MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Onoe --standard=802.11p-5MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Rraa --standard=802.11a --stepTime=0.1", "True", "True"),
@@ -83,7 +76,6 @@
     ("wifi-manager-example --wifiManager=Rraa --standard=802.11a --maxSlrc=1 --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Rraa --standard=802.11b --serverChannelWidth=22 --clientChannelWidth=22 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Rraa --standard=802.11g --stepTime=0.1", "True", "False"),
-    ("wifi-manager-example --wifiManager=Rraa --standard=802.11-holland --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Rraa --standard=802.11p-10MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Rraa --standard=802.11p-5MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Minstrel --standard=802.11a --stepTime=0.1", "True", "True"),
@@ -91,13 +83,11 @@
     ("wifi-manager-example --wifiManager=Minstrel --standard=802.11a --maxSlrc=1 --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Minstrel --standard=802.11b --serverChannelWidth=22 --clientChannelWidth=22 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Minstrel --standard=802.11g --stepTime=0.1", "True", "False"),
-    ("wifi-manager-example --wifiManager=Minstrel --standard=802.11-holland --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Minstrel --standard=802.11p-10MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Minstrel --standard=802.11p-5MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=MinstrelHt --standard=802.11a --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=MinstrelHt --standard=802.11b --serverChannelWidth=22 --clientChannelWidth=22 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=MinstrelHt --standard=802.11g --stepTime=0.1", "True", "False"),
-    ("wifi-manager-example --wifiManager=MinstrelHt --standard=802.11-holland --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=MinstrelHt --standard=802.11p-10MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=MinstrelHt --standard=802.11p-5MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=MinstrelHt --standard=802.11n-5GHz --serverChannelWidth=20 --clientChannelWidth=20 --serverShortGuardInterval=800 --clientShortGuardInterval=800 --serverNss=1 --clientNss=1 --stepTime=0.1", "True", "False"),
@@ -167,7 +157,6 @@
     ("wifi-manager-example --wifiManager=Ideal --standard=802.11a --stepTime=0.1", "True", "True"),
     ("wifi-manager-example --wifiManager=Ideal --standard=802.11b --serverChannelWidth=22 --clientChannelWidth=22 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Ideal --standard=802.11g --stepTime=0.1", "True", "False"),
-    ("wifi-manager-example --wifiManager=Ideal --standard=802.11-holland --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Ideal --standard=802.11p-10MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Ideal --standard=802.11p-5MHz --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=Ideal --standard=802.11n-5GHz --serverChannelWidth=20 --clientChannelWidth=20 --serverShortGuardInterval=800 --clientShortGuardInterval=800 --serverNss=1 --clientNss=1 --stepTime=0.1", "True", "False"),
